#include "adc.h"
#include <avr/interrupt.h>

static uint8_t values[4];
static uint8_t active_channel;

void adcStart(adc_channel_t channel) {
	active_channel = channel;
	ADCSRA |= (1<<ADEN);
	ADCSRA |= (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);	// enable, prescaler 8
	ADMUX = (1<<REFS0) | (1<<ADLAR) | channel;		// AVCC, left adjustment, channel
	// set reference
	ADCSRA |= (1<<ADSC) | (1<<ADIE);				// start
}

uint8_t adcGet(adc_channel_t channel) {
	return values[channel];
}

ISR(ADC_vect) {
	values[active_channel] = ADCH;
}