.PHONY: readme includefiles lib

LIB_FILE := $(BIN_DIR)/lib$(PROJ_NAME).tar.gz
.DEFAULT_GOAL := lib

LIB_HEADER := $(addprefix $(LIB_DIR)/, $(INCLUDE_HEADER))

-include $(PATH_TO_ME)default.mk

$(LIB_BUILD):
	@echo create directory: $@
	@mkdir $@

readme: | $(LIB_BUILD)
	@echo -e $(README_TEXT) | sed "s/^ *//" > $(LIB_BUILD)/readme.txt

includefiles: | $(LIB_BUILD)
	$(foreach lib, $(LIB_HEADER), $(shell cp $(lib)/*.h $(LIB_BUILD)))

$(LIB_BUILD)/lib$(PROJ_NAME).a: $(OBJS) | $(LIB_BUILD)
	@echo create library file
	@avr-ar rcs $@ $(OBJS)
	@avr-strip -S $@

lib: $(LIB_FILE)

$(LIB_FILE): $(LIB_BUILD)/lib$(PROJ_NAME).a readme includefiles | $(LIB_BUILD) $(BIN_DIR)
	@echo create package
	cd $(LIB_BUILD) && tar -pczf ../$(LIB_FILE) .
