#ifndef MESSAGE_TYPES
#define MESSAGE_TYPES

#include <inttypes.h>

typedef enum {
    INVALID,
    LUMINANCE_MSG,
    BUTTON_MSG,
    ENCODER_MSG,
    BL_MSG,
    RGB_MSG,
} message_type_t;

typedef struct {
    int8_t value;
} luminance_message_t;

typedef struct {
    int8_t value;
} button_message_t;

typedef struct {
    int8_t value;
} encoder_message_t;

typedef struct {
    uint16_t value;
} bl_message_t;

typedef struct {
    uint16_t red;
    uint16_t green;
    uint16_t blue;
} rgb_message_t;

typedef union {
    luminance_message_t luminance;
    button_message_t button;
    encoder_message_t encoder;
    bl_message_t bl;
    rgb_message_t rgb;
} message_t;

#endif
