#ifndef PWM_H
#define PWM_H

/*
 * provides 4 pwm channels
 * pwm resolution is 12bit
 * pwm frequency is about 60Hz
 */

#include <avr/io.h>
#include <avr/interrupt.h>

#define PWM_OFF	0
#define PWM_ON	4095
#define PWM_50P	(PWM_ON/2)

#define PWM_CHANNELS 4
#define PWM_TOP 0x3ff   // must be 2^x-1, x = pwm bit depth

#define PWM_PORT1	PORTD
#define PWM_DDR1	DDRD
#define PWM_MASK1	0xf0
#define PIN_OFFSET	4

typedef enum {
	PWM_BL = 0,
	PWM_R = 1,
	PWM_G = 2,
	PWM_B = 3,
} pwm_channel_t;

#define newCycle GPIOR0

extern void pwmInit();
extern void pwmSetDutyCycle(pwm_channel_t c, uint16_t dutyCycle);
//extern inline uint16_t pwmGetDutyCycle(pwm_channel_t c);
extern void pwmUpdate();
extern void pwmStart();
extern void pwmStop();

#endif
