from PyQt4.QtCore import SIGNAL, QObject
from PyQt4 import QtCore, QtGui

class State():
		VIEW = 1
		EDIT = 2

class AlarmLabel(QtGui.QWidget):
	def __init__(self, parent=None):
		super().__init__(parent)

		self.time = QtGui.QLabel(self)
		self.resize(128, 59)
		#self.time.setGeometry(QtCore.QRect(50, 20, 62, 16))
		#self.time.setObjectName("time")
		self.time.setText("00:00")

	def mousePressEvent(self, event):
		print("alarm label mouse click")


class AlarmState(QtGui.QWidget):
	def __init__(self, parent=None):
		super().__init__(parent)

		self.state = QtGui.QLabel(self)
		self.resize(59, 59)
		#self.state.setGeometry(QtCore.QRect(50, 20, 62, 16))
		#self.state.setObjectName("state")
		self.state.setText("e")

	def mousePressEvent(self, event):
		print("alarm state mouse click")


class AlarmWidget(QtGui.QWidget):
	def __init__(self, parent=None):
		QtGui.QWidget.__init__(self, parent)

		# create blink timer
		self.timer = QtCore.QTimer()
		self.timer.timeout.connect(self._blink)
		self.timer.setInterval(500)

		# set size
		self.setMinimumSize(QtCore.QSize(128, 59))
		self.setMaximumSize(QtCore.QSize(128, 59))

		self.horizontalLayout = QtGui.QHBoxLayout(self)

		self.time = AlarmLabel()
		self.state = AlarmState()

		self.horizontalLayout.addWidget(self.time)
		self.horizontalLayout.addWidget(self.state)

		# init state
		self.state = State.VIEW
		self.active = False
		self._update_view()

	def _blink(self):
		#self.ui.time.setVisible(not self.ui.time.isVisible())
		pass

	def _edit(self):
		#self.ui.time.setVisible(False)
		self.timer.start()
		self.state = State.EDIT
		self.setFocus()

		# add edit timeout

	def _cancel(self):
		self._leave()

	def _store(self):
		self._activate()
		self._leave()

	def _leave(self):
		self.timer.stop()
		#self.ui.time.setVisible(True)
		self.state = State.VIEW
		self._update_view()
		self.clearFocus()

	def _activate(self):
		self.active = True

	def _deactivate(self):
		self.active = False

	def _toggle(self):
		self.active = not self.active

	def _update_view(self):
		if self.active:
			#self.ui.state.setText("a")
			self.emit(SIGNAL('showMessage'), "update timer")
		else:
			#self.ui.state.setText("")
			pass

	def focusOutEvent(self, event):
		event.accept()
		self._cancel()

	def keyPressEvent(self, event):
		if type(event) == QtGui.QKeyEvent:
			print("alarm: " + str(event.key()))
			if event.key() == QtCore.Qt.Key_X:
				event.ignore()
				return
			if event.key() == QtCore.Qt.Key_Up:
				self.alarm1._edit()
			if event.key() == QtCore.Qt.Key_Down:
				self.alarm1._store()
			if event.key() == QtCore.Qt.Key_Escape:
				self._cancel()
			if event.key() == QtCore.Qt.Key_Return:
				self._store()

			event.accept()
		else:
			event.ignore()

	def mouseDoubleClickEvent(self, event):
		print("alarm mouse double click")
		self._toggle()
		self._cancel()

		event.accept()

	def mousePressEvent(self, event):
		print("alarm mouse click")

		if self.state == State.VIEW:
			self._edit()

		elif self.state == State.EDIT:
			self._store()

		event.accept()
