from PyQt4 import QtCore
import subprocess
import RPi.GPIO as gpio

# todo: try wiring pi, should run without root

class AudioControl(QtCore.QObject):
	def __init__(self, parent=None):
		super().__init__(parent)

		self.AUDIO_EN = 17
		self.RESET = 18
		self.BOOT = 19

		gpio.setmode(gpio.BCM)
		gpio.setwarnings(False)

		gpio.setup(self.AUDIO_EN, gpio.OUT, initial=gpio.HIGH)

		# reset firmware, todo: move
		gpio.setup(self.RESET, gpio.OUT, initial=gpio.LOW)	
		gpio.setup(self.BOOT, gpio.OUT, initial=gpio.HIGH)	
		gpio.output(self.RESET, gpio.HIGH)
		gpio.setup(self.BOOT, gpio.IN)	

	def enable(self):
		gpio.output(self.AUDIO_EN, gpio.LOW)

	def disable(self):
		gpio.output(self.AUDIO_EN, gpio.HIGH)

	def set_volume(self, volume):
		subprocess.call(['amixer', '-q', 'set', 'PCM', str(volume)+'%%'])
