import sys
from PyQt4 import QtCore, QtGui
from main_widget import MainWindow
from gui_control import GuiControl
from alarm_control import AlarmControl
from datetime import datetime
from input import *
from message import Message
from weather import WeatherThread

class StackUi(QtGui.QWidget):
	def __init__(self, parent=None):
		QtGui.QWidget.__init__(self, parent)
		self.ui = Ui_stack()
		self.ui.setupUi(self)


if __name__ == "__main__":
	app = QtGui.QApplication(sys.argv)
	gui = MainWindow()

	input = Message()
	input.start()

	weather = WeatherThread()
	weather.start()

	# start threads
	alarmControl = AlarmControl()

	control = GuiControl(alarmControl)

	# connect
	alarmControl.minTick.connect(gui.updateClock)
	alarmControl.minTick.connect(control.timeAction)
	gui.alarm1Click.connect(control.alarm1Click)
	gui.alarm2Click.connect(control.alarm2Click)
	gui.active1Click.connect(control.active1Click)
	gui.active2Click.connect(control.active2Click)
	gui.timeClick.connect(control.timeClick)
	gui.wlanOnClick.connect(control.wlanOnClick)
	gui.wlanOffClick.connect(control.wlanOffClick)
	#gui.lightOnClick.connect(control.lightOn)
	#gui.lightOffClick.connect(control.lightOff)
	gui.redChanged.connect(control.setRed)
	gui.greenChanged.connect(control.setGreen)
	gui.blueChanged.connect(control.setBlue)
	control.toggleMenu.connect(gui.toggleMenu)
	control.setAlarmTime1.connect(gui.setAlarmTime1)
	control.setAlarmTime2.connect(gui.setAlarmTime2)
	control.setAlarmStatus1.connect(gui.setAlarmStatus1)
	control.setAlarmStatus2.connect(gui.setAlarmStatus2)
	control.setBlinkStatus1.connect(gui.setBlinkStatus1)
	control.setBlinkStatus2.connect(gui.setBlinkStatus2)
	control.showMessage.connect(gui.showMessage)
	control.clearMessage.connect(gui.clearMessage)
	control.setBrightness.connect(input.sendBacklite)
	control.setLight.connect(input.sendRGB)
	control.setDayColors.connect(gui.setDayColors)
	control.setNightColors.connect(gui.setNightColors)
	control.updateWeather.connect(weather.triggerUpdate)
	input.button1.connect(control.button1);
	input.button2.connect(control.button2);
	input.buttonE.connect(control.buttonE);
	input.encoder.connect(control.encoder);
	input.luminance.connect(control.updateLuminance);
	weather.setFcTemp.connect(gui.setFcTemp)
	weather.setFcRain.connect(gui.setFcRain)
	weather.setFcIcon.connect(gui.setFcIcon)

	control.refresh()
	weather.triggerUpdate()

	# start appliation
	gui.show()
	sys.exit(app.exec_())

