from qt_menu import *
from PyQt4 import QtCore, QtGui
from settings import Settings

class MenuWidget(QtGui.QWidget):
	wlanOnClick = QtCore.pyqtSignal()
	wlanOffClick = QtCore.pyqtSignal()
	#lightOnClick = QtCore.pyqtSignal()
	#lightOffClick = QtCore.pyqtSignal()
	redChanged = QtCore.pyqtSignal(int)
	greenChanged = QtCore.pyqtSignal(int)
	blueChanged = QtCore.pyqtSignal(int)

	def __init__(self, parent=None):
		QtGui.QWidget.__init__(self, parent)
		self.ui = Ui_menu()
		self.ui.setupUi(self)

		settings = Settings()

		self.ui.red.setValue(settings.red)
		self.ui.green.setValue(settings.green)
		self.ui.blue.setValue(settings.blue)

		self.ui.wlanOn.pressed.connect(self.wlanOnClick)
		self.ui.wlanOff.pressed.connect(self.wlanOffClick)
		#self.ui.lightOn.pressed.connect(self.lightOnClick)
		#self.ui.lightOff.pressed.connect(self.lightOffClick)
		self.ui.red.valueChanged.connect(self.redChanged)
		self.ui.green.valueChanged.connect(self.greenChanged)
		self.ui.blue.valueChanged.connect(self.blueChanged)

		self.ui.red_up.clicked.connect(self.red_up)
		self.ui.green_up.clicked.connect(self.green_up)
		self.ui.blue_up.clicked.connect(self.blue_up)
		self.ui.red_down.clicked.connect(self.red_down)
		self.ui.green_down.clicked.connect(self.green_down)
		self.ui.blue_down.clicked.connect(self.blue_down)

	def red_up(self):
		self.ui.red.setValue(self.ui.red.value() + 50)

	def green_up(self):
		self.ui.green.setValue(self.ui.green.value() + 50)

	def blue_up(self):
		self.ui.blue.setValue(self.ui.blue.value() + 50)

	def red_down(self):
		self.ui.red.setValue(self.ui.red.value() - 50)

	def green_down(self):
		self.ui.green.setValue(self.ui.green.value() - 50)

	def blue_down(self):
		self.ui.blue.setValue(self.ui.blue.value() - 50)