from PyQt4 import QtCore

class Settings():
	__instance = None

	def __new__(self):
		if Settings.__instance is None:
			Settings.__instance = object.__new__(self)
			#Settings.__instance = self

			#self.app_dir = '.'
			self.app_dir = '/opt/wecker'

			# set defaults
			self.volume_max = 95
			self.volume_enable = 43
			self.volume_min = 40
			self.sound = self.app_dir + '/sound/alarm.mp3'
			self.active_alarm_icon = self.app_dir + '/src/icons/alarm_active.gif'
			self.inactive_alarm_icon = self.app_dir + '/src/icons/alarm_inactive.gif'
			self.weather_icon_path = self.app_dir + '/src/icons/weather'
			self.forground_night = QtCore.Qt.white
			self.forground_day = QtCore.Qt.black
			self.background_night = QtCore.Qt.black
			self.background_day = QtCore.Qt.white

			self.alarm1_minutes = 0
			self.alarm1_hours = 0
			self.alarm1_active = False
			self.alarm2_minutes = 0
			self.alarm2_hours = 0
			self.alarm2_active = False

			self.red = 0
			self.green = 0
			self.blue = 0

			# load settings
			self.load(self)

		return Settings.__instance

	def load(self):
		s = QtCore.QSettings('/home/pi/.wecker', 0)
		self.alarm1_minutes = s.value('a1_min', 0, type=int)
		self.alarm1_hours = s.value('a1_hour', 0, type=int)
		self.alarm1_active = s.value('a1_active', False, type=bool)
		self.alarm2_minutes = s.value('a2_min', 0, type=int)
		self.alarm2_hours = s.value('a2_hour', 0, type=int)
		self.alarm2_active = s.value('a2_active', False, type=bool)
		self.red = s.value('red', 0, type=int)
		self.green = s.value('green', 0, type=int)
		self.blue = s.value('blue', 0, type=int)

	def store(self):
		s = QtCore.QSettings('/home/pi/.wecker', 0)
		s.setValue('a1_min', self.alarm1_minutes)
		s.setValue('a1_hour', self.alarm1_hours)
		s.setValue('a1_active', self.alarm1_active)
		s.setValue('a2_min', self.alarm2_minutes)
		s.setValue('a2_hour', self.alarm2_hours)
		s.setValue('a2_active', self.alarm2_active)
		s.setValue('red', self.red)
		s.setValue('green', self.green)
		s.setValue('blue', self.blue)
		del s

