
from audio_control import AudioControl
import sys
import subprocess
from PyQt4 import QtCore
from settings import Settings

class Sound(AudioControl):
	def __init__(self, parent=None):
		super().__init__(parent)
		self.player = None
		self.inc_timer = QtCore.QTimer()
		self.inc_timer.timeout.connect(self._increase_volume)
		self.inc_timer.setInterval(1000)
		self.volume = 0

		self.dec_timer = QtCore.QTimer()
		self.dec_timer.timeout.connect(self._decrease_volume)
		self.dec_timer.setInterval(10)

		self.settings = Settings()

	def _increase_volume(self):
		if self.volume < self.settings.volume_max:
			self.volume = self.volume+1
			#print("inc to", str(self.volume))
			self.set_volume(self.volume)

		if self.volume == self.settings.volume_enable:
			self.enable()

	def _decrease_volume(self):
		if self.volume > 10:
			self.volume = self.volume-3
			self.set_volume(self.volume)
		else:
			self.stop();

	def start_play(self, file):
		self.volume = self.settings.volume_min
		self._increase_volume()
		self.inc_timer.start()
		self.dec_timer.stop()
		self.player = subprocess.Popen(['mpg123', '-Z', '-q', file])

	def playIncreasing(self, file):
		self.start_play(file)

	def stopDecreasing(self):
		self.inc_timer.stop();
		self.dec_timer.start();

	def stop(self):
		if self.player:
			self.player.terminate()
			self.player = None
		self.inc_timer.stop()
		self.dec_timer.stop()
		self.disable()




