import json
from datetime import date
from datetime import datetime
from datetime import timedelta
from urllib import request
from PyQt4 import QtCore

class WeatherInfo:
	def __init__(self, info):
		#self.temp_min = min(info['11:00']['tn'], info['17:00']['tn'])
		#self.temp_max = max(info['11:00']['tx'], info['17:00']['tx'])
		self.temp_min = int(info['tn'])
		self.temp_max = int(info['tx'])
		self.rain = int(info['pc'])
		self.text = info['tx']
		self.code = int(info['w'])
		self.image = 'd_' + str(self.code) + '_K.png'

	def __str__(self):
		s = 't: ' + self.temp_min + '/' + self.temp_max + '\n'
		s = s + 'r: ' + self.rain + '%' + '\n'
		s = s + self.text + '\n'
		s = s + self.image + '\n'
		return s


class Weather:
	def __init__(self):
		self.today = None
		self.tomorrow = None

	def update(self):
		self.today = None
		self.tomorrow = None
		response = request.urlopen('http://api.wetter.com/forecast/weather/city/ATAT10678010/project/weckerabc/cs/40396c094a75f0a1e57e11769417cd68/output/json')
		json_info = response.read().decode()
		info = json.loads(json_info)

		fc = info['city']['forecast']

		self.today = WeatherInfo(fc[str(date.today())])
		self.tomorrow = WeatherInfo(fc[str(date.today() + timedelta(days=1))])


class WeatherThread(QtCore.QThread):
	setFcTemp = QtCore.pyqtSignal(str)
	setFcRain = QtCore.pyqtSignal(str)
	setFcIcon = QtCore.pyqtSignal(str)

	def __init__(self, parent=None):
		super().__init__()
		self.start_sig = QtCore.QSemaphore()
		self.weather = Weather()

	def triggerUpdate(self):
		self.start_sig.release()

	def run(self):
		while True:
			self.start_sig.acquire()

			try:
				self.weather.update()

				if datetime.today().hour > 15:
					weather_info = self.weather.tomorrow
				else:
					weather_info = self.weather.today

				temp = str(weather_info.temp_min) + '/' + str(weather_info.temp_max) + '°C'

				if weather_info.rain > 40:
					rain = str(weather_info.rain) + '%'
				else:
					rain = ''

				self.setFcTemp.emit(temp)
				self.setFcRain.emit(rain)
				self.setFcIcon.emit(weather_info.image)

			except:
				self.setFcTemp.emit('')
				self.setFcRain.emit('')
				self.setFcIcon.emit('')


